---------------------------------------------------------------
-- Rigging Tools 0.45
-- Alden Filion / pDe
-- alden@aldenfilion.com
-- 2005
---------------------------------------------------------------
fn rigStick pnt xsize ysize jState jName =
(
	masrect = Rectangle length:(xsize/8) width:(xsize/8) cornerRadius:0 transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [pnt.x + (xsize/2),pnt.y,pnt.z + (ysize/2)])
	if (jName == "") then jName = "masControl"
	masrect.name = jName
	rect = Rectangle length:ysize width:xsize cornerRadius:0 transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] pnt)
	rect.name = jName + "_rect"
	circ = Circle radius:(ysize/8) transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] pnt)
	circ.name = jName + "_circ"
	tyPos = pnt.z - ((ySize/2)+((ysize+xsize)/8))
	txt = text size:((ysize+xsize)/8) kerning:0 leading:0 transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [pnt.x, pnt.y,tyPos])
	txt.text = jName
	txt.name = jName + "_text"
	txt.parent = masrect
	circ.parent = rect
	rect.parent = masrect
	masrect.wirecolor = color 255 255 0
	rect.wirecolor = color 88 199 225
	circ.wirecolor = color 224 198 87	
	NIK = iksys.ikchain rect circ "IKHISolver"
	NIK.parent = masRect
	NIK.name = jName + "_IKChain"
	hide NIK
	rect.transform.controller.RotXActive = off
	rect.transform.controller.RotYActive = off
	rect.transform.controller.RotZActive = off
	
	circ.transform.controller.PosXActive = on
	circ.transform.controller.PosXLimited = on
	circ.transform.controller.PosXLLimited = on
	circ.transform.controller.PosXULimited = on
	if (jState[1] == 1) then
	(
		circ.transform.controller.PosXLLimit = 0
		circ.transform.controller.PosXULimit = 0
	)else(
		circ.transform.controller.PosXLLimit = -(xsize/2)
		circ.transform.controller.PosXULimit = (xsize/2)
	)	
	circ.transform.controller.PosYActive = on
	circ.transform.controller.PosYLimited = on
	circ.transform.controller.PosYLLimited = on	
	circ.transform.controller.PosYULimited = on
	if (jState[2] == 1) then
	(
		circ.transform.controller.PosYLLimit = 0
		circ.transform.controller.PosYULimit = 0
	)else(
		circ.transform.controller.PosYLLimit = -(ysize/2)
		circ.transform.controller.PosYULimit = (ysize/2)
	)	
	select circ	
)
plugin geometry rig_tool 
name:"Rig Tools" 
category:"Rigging Tools" 
( 
	--Joystick Locals
	local sel = 1
	local sizeX = 5.0
	local sizeY = 5.0
	local joystate = #(0,0)
	local joyName = ""
	tool create 
	(
		on mousePoint click do 
		(  
			clickAt = worldPoint
			case (sel) of
			(
				1: (	rigStick clickAt sizeX sizeY joystate joyName			
						#stop
					)			
			)		
		)
	)
	rollout main "Rigging Tools" 
	( 
		radiobuttons objs labels:#("JoyStick") columns:2	
		on objs changed state do
		(
			sel = state
		)		
	)	
	rollout rigStickparams "Parameters" 
	(
		editText edt1 "Name"
		spinner wid "Width" range:[.001,10,sizeX] align:#center width:120 enabled:true
		spinner hei "Height" range:[.001,10,sizeY] align:#center width:120 enabled:true		
		checkbox chk1 "Lock X" across:2
		checkbox chk2 "Lock Y"
		
		on wid changed val do 
		(
			sizeX = val
		)
		on hei changed val do 
		(
			sizeY = val
		)
		on chk1 changed arg do
		(
			case (arg) of
			(
				true: (
						joystate[1] = 1
						chk2.checked = false
						)
				false: joystate[1] = 0 
			)
		)
		on chk2 changed arg do
		(
			case (arg) of
			(
				true: (
						joystate[2] = 1
						chk1.checked = false
						)
				false: joystate[2] = 0 
			)
		)
		on edt1 changed arg do
		(
			joyName = arg
		)
	)
)